// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.go from MIMXRT1011.svd, see https://github.com/posborne/cmsis-svd/tree/master/data/NXP

// MIMXRT1011DAE5A
//
//     Copyright 2016-2019 NXP All rights reserved. SPDX-License-Identifier: BSD-3-Clause

.syntax unified

// This is the default handler for interrupts, if triggered but not defined.
.section .text.Default_Handler
.global  Default_Handler
.type    Default_Handler, %function
Default_Handler:
    wfe
    b    Default_Handler
.size Default_Handler, .-Default_Handler

// Avoid the need for repeated .weak and .set instructions.
.macro IRQ handler
    .weak  \handler
    .set   \handler, Default_Handler
.endm

// Must set the "a" flag on the section:
// https://svnweb.freebsd.org/base/stable/11/sys/arm/arm/locore-v4.S?r1=321049&r2=321048&pathrev=321049
// https://sourceware.org/binutils/docs/as/Section.html#ELF-Version
.section .isr_vector, "a", %progbits
.global  __isr_vector
__isr_vector:
    // Interrupt vector as defined by Cortex-M, starting with the stack top.
    // On reset, SP is initialized with *0x0 and PC is loaded with *0x4, loading
    // _stack_top and Reset_Handler.
    .long _stack_top
    .long Reset_Handler
    .long NMI_Handler
    .long HardFault_Handler
    .long MemoryManagement_Handler
    .long BusFault_Handler
    .long UsageFault_Handler
    .long 0
    .long 0
    .long 0
    .long 0
    .long SVC_Handler
    .long DebugMon_Handler
    .long 0
    .long PendSV_Handler
    .long SysTick_Handler

    // Extra interrupts for peripherals defined by the hardware vendor.
    .long DMA0_IRQHandler
    .long DMA1_IRQHandler
    .long DMA2_IRQHandler
    .long DMA3_IRQHandler
    .long DMA4_IRQHandler
    .long DMA5_IRQHandler
    .long DMA6_IRQHandler
    .long DMA7_IRQHandler
    .long DMA8_IRQHandler
    .long DMA9_IRQHandler
    .long DMA10_IRQHandler
    .long DMA11_IRQHandler
    .long DMA12_IRQHandler
    .long DMA13_IRQHandler
    .long DMA14_IRQHandler
    .long DMA15_IRQHandler
    .long DMA_ERROR_IRQHandler
    .long CTI0_ERROR_IRQHandler
    .long CTI1_ERROR_IRQHandler
    .long CORE_IRQHandler
    .long LPUART1_IRQHandler
    .long LPUART2_IRQHandler
    .long LPUART3_IRQHandler
    .long LPUART4_IRQHandler
    .long PIT_IRQHandler
    .long USB_OTG1_IRQHandler
    .long FLEXSPI_IRQHandler
    .long FLEXRAM_IRQHandler
    .long LPI2C1_IRQHandler
    .long LPI2C2_IRQHandler
    .long GPT1_IRQHandler
    .long GPT2_IRQHandler
    .long LPSPI1_IRQHandler
    .long LPSPI2_IRQHandler
    .long PWM1_0_IRQHandler
    .long PWM1_1_IRQHandler
    .long PWM1_2_IRQHandler
    .long PWM1_3_IRQHandler
    .long PWM1_FAULT_IRQHandler
    .long KPP_IRQHandler
    .long SRC_IRQHandler
    .long GPR_IRQ_IRQHandler
    .long CCM_1_IRQHandler
    .long CCM_2_IRQHandler
    .long EWM_IRQHandler
    .long WDOG2_IRQHandler
    .long SNVS_HP_WRAPPER_IRQHandler
    .long SNVS_HP_WRAPPER_TZ_IRQHandler
    .long SNVS_LP_WRAPPER_IRQHandler
    .long CSU_IRQHandler
    .long DCP_IRQHandler
    .long DCP_VMI_IRQHandler
    .long Reserved68_IRQHandler
    .long TRNG_IRQHandler
    .long Reserved70_IRQHandler
    .long Reserved71_IRQHandler
    .long SAI1_IRQHandler
    .long RTWDOG_IRQHandler
    .long SAI3_RX_IRQHandler
    .long SAI3_TX_IRQHandler
    .long SPDIF_IRQHandler
    .long PMU_IRQHandler
    .long XBAR1_IRQ_0_1_2_3_IRQHandler
    .long TEMP_LOW_HIGH_IRQHandler
    .long TEMP_PANIC_IRQHandler
    .long USB_PHY_IRQHandler
    .long GPC_IRQHandler
    .long ADC1_IRQHandler
    .long FLEXIO1_IRQHandler
    .long DCDC_IRQHandler
    .long GPIO1_Combined_0_15_IRQHandler
    .long GPIO1_Combined_16_31_IRQHandler
    .long GPIO2_Combined_0_15_IRQHandler
    .long GPIO5_Combined_0_15_IRQHandler
    .long WDOG1_IRQHandler
    .long ADC_ETC_IRQ0_IRQHandler
    .long ADC_ETC_IRQ1_IRQHandler
    .long ADC_ETC_IRQ2_IRQHandler
    .long ADC_ETC_IRQ3_IRQHandler
    .long ADC_ETC_ERROR_IRQ_IRQHandler

    // Define default implementations for interrupts, redirecting to
    // Default_Handler when not implemented.
    IRQ NMI_Handler
    IRQ HardFault_Handler
    IRQ MemoryManagement_Handler
    IRQ BusFault_Handler
    IRQ UsageFault_Handler
    IRQ SVC_Handler
    IRQ DebugMon_Handler
    IRQ PendSV_Handler
    IRQ SysTick_Handler
    IRQ DMA0_IRQHandler
    IRQ DMA1_IRQHandler
    IRQ DMA2_IRQHandler
    IRQ DMA3_IRQHandler
    IRQ DMA4_IRQHandler
    IRQ DMA5_IRQHandler
    IRQ DMA6_IRQHandler
    IRQ DMA7_IRQHandler
    IRQ DMA8_IRQHandler
    IRQ DMA9_IRQHandler
    IRQ DMA10_IRQHandler
    IRQ DMA11_IRQHandler
    IRQ DMA12_IRQHandler
    IRQ DMA13_IRQHandler
    IRQ DMA14_IRQHandler
    IRQ DMA15_IRQHandler
    IRQ DMA_ERROR_IRQHandler
    IRQ CTI0_ERROR_IRQHandler
    IRQ CTI1_ERROR_IRQHandler
    IRQ CORE_IRQHandler
    IRQ LPUART1_IRQHandler
    IRQ LPUART2_IRQHandler
    IRQ LPUART3_IRQHandler
    IRQ LPUART4_IRQHandler
    IRQ PIT_IRQHandler
    IRQ USB_OTG1_IRQHandler
    IRQ FLEXSPI_IRQHandler
    IRQ FLEXRAM_IRQHandler
    IRQ LPI2C1_IRQHandler
    IRQ LPI2C2_IRQHandler
    IRQ GPT1_IRQHandler
    IRQ GPT2_IRQHandler
    IRQ LPSPI1_IRQHandler
    IRQ LPSPI2_IRQHandler
    IRQ PWM1_0_IRQHandler
    IRQ PWM1_1_IRQHandler
    IRQ PWM1_2_IRQHandler
    IRQ PWM1_3_IRQHandler
    IRQ PWM1_FAULT_IRQHandler
    IRQ KPP_IRQHandler
    IRQ SRC_IRQHandler
    IRQ GPR_IRQ_IRQHandler
    IRQ CCM_1_IRQHandler
    IRQ CCM_2_IRQHandler
    IRQ EWM_IRQHandler
    IRQ WDOG2_IRQHandler
    IRQ SNVS_HP_WRAPPER_IRQHandler
    IRQ SNVS_HP_WRAPPER_TZ_IRQHandler
    IRQ SNVS_LP_WRAPPER_IRQHandler
    IRQ CSU_IRQHandler
    IRQ DCP_IRQHandler
    IRQ DCP_VMI_IRQHandler
    IRQ Reserved68_IRQHandler
    IRQ TRNG_IRQHandler
    IRQ Reserved70_IRQHandler
    IRQ Reserved71_IRQHandler
    IRQ SAI1_IRQHandler
    IRQ RTWDOG_IRQHandler
    IRQ SAI3_RX_IRQHandler
    IRQ SAI3_TX_IRQHandler
    IRQ SPDIF_IRQHandler
    IRQ PMU_IRQHandler
    IRQ XBAR1_IRQ_0_1_2_3_IRQHandler
    IRQ TEMP_LOW_HIGH_IRQHandler
    IRQ TEMP_PANIC_IRQHandler
    IRQ USB_PHY_IRQHandler
    IRQ GPC_IRQHandler
    IRQ ADC1_IRQHandler
    IRQ FLEXIO1_IRQHandler
    IRQ DCDC_IRQHandler
    IRQ GPIO1_Combined_0_15_IRQHandler
    IRQ GPIO1_Combined_16_31_IRQHandler
    IRQ GPIO2_Combined_0_15_IRQHandler
    IRQ GPIO5_Combined_0_15_IRQHandler
    IRQ WDOG1_IRQHandler
    IRQ ADC_ETC_IRQ0_IRQHandler
    IRQ ADC_ETC_IRQ1_IRQHandler
    IRQ ADC_ETC_IRQ2_IRQHandler
    IRQ ADC_ETC_IRQ3_IRQHandler
    IRQ ADC_ETC_ERROR_IRQ_IRQHandler

.size __isr_vector, .-__isr_vector
